/*	Copyright 1992 H.Ogasawara (COR.)	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"

#define		MAGLOADER	"mag.r"

static int		sizex, sizey;
static unsigned char	com[1024];
static int		color;
static unsigned char	*mag_palet;

static
size_check( fname )
char	*fname;
{
	int	fn;
	unsigned char	*p;
	if( (fn= OPEN( fname, 0 )) >= 0 ){
		READ( fn, p= com, 1024 );
		CLOSE( fn );
		if( strncmp( p, "MAKI02  ", 8 ) ){
			GV_Err( "magtH[}bgႢ܂" );
			return	FALSE;
		}
		for( com[1023]= 0x1a ; *p != 0x1a ; p++ );
		*p++= '\0';
		for( com[1023]= 0    ; *p != 0x00 ; p++ );
		mag_palet= p+32;
		p++;		/* skip wb_擪	*/
		p++;		/* @R[h	*/
		p++;		/* @ˑtO	*/
		color= *p++ & 128;	/* XN[[h	*/
		sizex= (p[1]<<8)+*p; p+= 2;	/* JnX */
		sizey= (p[1]<<8)+*p; p+= 2;	/* JnY */
		sizex= (p[1]<<8)+*p - sizex +1; p+= 2;	/* IX */
		sizey= (p[1]<<8)+*p - sizey +1; p+= 2;	/* IY */
		return	TRUE;
	}
	GV_Err( "magI[vł܂" );
	return	FALSE;
}

GVIEW *
GV_Load_Mag( fname )
char	*fname;
{
	if( size_check( fname ) ){
		GVIEW	*gp;
		if( !(gp= GV_Alloc( sizex, sizey, color ?
							WindowAttrGraphic256 :
							WindowAttrGraphic16,
							fname, com+8, 0 )) ){
			GV_Err( "܂" );
			return	NULL;
		}
		if( GV_VramGetExec( MAGLOADER, fname, gp ) ){
			MFREE( gp );
			GV_Err2( MAGLOADER, "sł܂ł" );
			return	NULL;
		}
		memcpy( gp->base_palet, mag_palet, GV_PaletSize(gp->color)*3 );
		GV_BaseToPalet( gp );
		return	gp;
	}
	return	NULL;
}
